杭电1394 Minimum Inversion Number(线段树)

Minimum Inversion Number

Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other)
Total Submission(s) : 1   Accepted Submission(s) : 1

Problem Description

The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the
seqence, we will obtain another sequence. There are totally n such sequences as the following: a1, a2, ..., an-1, an (where m = 0 - the initial seqence) a2, a3, ..., an, a1 (where m = 1) a3, a4, ..., an, a1, a2 (where m = 2) ... an, a1, a2, ..., an-1 (where
m = n-1) You are asked to write a program to find the minimum inversion number out of the above sequences.

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

Output

For each case, output the minimum inversion number on a single line.

Sample Input

10
1 3 6 9 0 8 5 7 4 2

Sample Output

16

Author

CHEN, Gaoli

/*
郁闷……线段树总是错都不知道哪儿错了 渣渣备注了半天结果发现抄都抄不对
加油!!!
Time:2014-8-26 16:52
*/
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
#define L(rt) (rt<<1)
#define R(rt) (rt<<1|1)
const int MAX=5000+10;
struct Tree{
	int L;
	int R;
	int cnt;
}tree[MAX<<2];//四倍即可
void BuildTree(int rt,int L,int R){
	tree[rt].L=L;
	tree[rt].R=R;
	tree[rt].cnt=0;
	if(tree[rt].L==tree[rt].R){
		return ;
	}
	int mid=((L+R)>>1);//L+R传入的 不是tree[rt].L 

	BuildTree(L(rt),L,mid);
	BuildTree(R(rt),mid+1,R);
}
void Modify(int rt,int pos){
	if(tree[rt].L==pos&&tree[rt].R==pos){
		tree[rt].cnt++;//可以直接等于 1 即用 1标记
		return ;
	}
	int mid=((tree[rt].L+tree[rt].R)>>1);
	if(pos<=mid){
		Modify(L(rt),pos);
	}else if(pos>mid){
		Modify(R(rt),pos);
	}

	tree[rt].cnt=tree[L(rt)].cnt+tree[R(rt)].cnt;
}
int Query(int rt,int L,int R){
	if(tree[rt].L==L&&tree[rt].R==R){
		return tree[rt].cnt;
	}
	int mid=((tree[rt].L+tree[rt].R)>>1);
	if(R<=mid){
		return Query(L(rt),L,R);
	}else if(L>mid){
		return Query(R(rt),L,R);
	}else{
		return Query(L(rt),L,mid)+Query(R(rt),mid+1,R);
	}
}
void solve(){
	int N;
	int a[MAX];
	while(scanf("%d",&N)!=EOF){
		BuildTree(1,0,N);
		int sum=0;
		for(int i=1;i<=N;i++){
			scanf("%d",&a[i]);
			sum+=Query(1,a[i],N);//询问从 a[i]+1到 n 中的值的个数。即比 a[i]大的即可与a[i]构成
			//即比 a[i] 大的值的所有逆序对之和
			Modify(1,a[i]);//修改的 只需知道位置即可,根节点为1 传入根节点和位置即可 增量 1
		}

		int ans=sum;
		for(int i=1;i<=N;i++){
			sum=sum-a[i]+(N-a[i]-1);//因为输入 0 到  n-1,比 a[i]小的 就有 a[i]个
			//一共 n个数,把第一个移到后边则它增加 的逆序对数为总数 n它减少的逆序对数再减掉它本身
			// 比如 3 6 9 0 8 5 7 4 2 1 把 3移到后边就应该把 由 3组成的逆序对数减掉 即比 3 小的个数
			//移到最后 一位后,由3增加的逆序对数个数  为比他大的数构成,之和加上它本身刚好为 n
			ans=min(ans,sum);
		}
		printf("%d\n",ans);
	}
}
int main(){
	solve();
return 0;
}
时间: 2024-10-10 18:20:33

杭电1394 Minimum Inversion Number(线段树)的相关文章

hdu 1394 Minimum Inversion Number 线段树 点更新

// hdu 1394 Minimum Inversion Number 线段树 点更新 // // 典型线段树的单点更新 // // 对于求逆序数,刚开始还真的是很年轻啊,裸的按照冒泡排序 // 求出最初始的逆序数,然后按照公式递推,结果就呵呵了 // // 发现大牛都是用线段树和树状数组之类的做的,而自己又在学 // 线段树,所以就敲了线段树. // // 线段树的节点保存一段区间( L,R )内0,1...n一共出现了多少个. // 因为每个数是0,1,2...n-1且没有重复的数字. /

HDU 1394 Minimum Inversion Number.(线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 ~~~~ 早起一发线段树,开心又快乐.这题暴力也能水过,同时线段树的效率也就体现的尤为明显了,看了大牛的博客,说是还可以用树状数组,点树和合并序列写,现在还不懂,留着以后在写吧. ~~~~ 大致题意:给定一个数字序列,同时由此可以得到n个序列, 要求从n个序列中找到逆序数最小的序列,输出最小逆序数. 首先介绍下逆序数的概念: 在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面

HDU 1394 Minimum Inversion Number (线段树,单点更新)

C - Minimum Inversion Number Crawling in process... Crawling failed Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 1394 Appoint description: System Crawler (2015-08-17) Description The inversio

Hdu 1394 Minimum Inversion Number(线段树或树状数组)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11981    Accepted Submission(s): 7321 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 1394 Minimum Inversion Number (线段树,暴力)

Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seq

hdu 1394 Minimum Inversion Number 线段树

Problem Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of

hdu - 1394 Minimum Inversion Number(线段树水题)

http://acm.hdu.edu.cn/showproblem.php?pid=1394 很基础的线段树. 先查询在更新,如果后面的数比前面的数小肯定会查询到前面已经更新过的值,这时候返回的sum就是当前数的逆序数. 这样查询完之后得到初始数列的逆序数,要求得所有序列的最小逆序数,还需要循环一次. 设初始序列abcde中逆序数为k,小于a的个数是t-1那么大于a的个数就是n-t,当把a左移一位,原来比a大的都变成了a的逆序对,即逆序数增加了n-t,但是原来比a小的数都变成了顺序, 因此逆序数

Minimum Inversion Number(线段树单点更新+逆序数)

Minimum Inversion Number(线段树单点更新+逆序数) Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy

hdu 1394 Minimum Inversion Number (裸树状数组 求逆序数)

题目链接 题意: 给一个n个数的序列a1, a2, ..., an ,这些数的范围是0-n-1, 可以把前面m个数移动到后面去,形成新序列:a1, a2, ..., an-1, an (where m = 0 - the initial seqence)a2, a3, ..., an, a1 (where m = 1)a3, a4, ..., an, a1, a2 (where m = 2)...an, a1, a2, ..., an-1 (where m = n-1)求这些序列中,逆序数最少的